package com.glarimy.atlas.api;

public interface Atlas {
	/**
	 * Searches for country details based on the specified country name.
	 * 
	 * @param countryName
	 *            key
	 * @return country details whose name is the key
	 * @throws InvalidKeyException
	 *             if key is null or empty string
	 * @throws CountryNotFoundException
	 *             if there is no country found with the given key
	 * @throws AtlasException
	 *             for all other internal erros
	 */
	public Country search(String countryName) throws InvalidKeyException,
			CountryNotFoundException, AtlasException;

	public void add(Country country) throws InvalidCountryException,
			DuplicateCountryException, AtlasException;
}
