package com.glarimy.atlas.api;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;


public class AtlasProxy implements Atlas {
	public void add(Country country) throws InvalidCountryException,
			DuplicateCountryException, AtlasException {
		try {
			Socket socket = new Socket("localhost", 1234);
			ObjectOutputStream oos = new ObjectOutputStream(
					socket.getOutputStream());
			PDU request = new PDU();
			request.setHeader(AtlasProtocol.ADD_COUNTRY_REQ);
			request.setPayload(country);
			System.out.println("Adding counry ....");
			oos.writeObject(request);
			ObjectInputStream ois = new ObjectInputStream(
					socket.getInputStream());
			PDU response = (PDU) ois.readObject();
			if (response.getHeader() == AtlasProtocol.ADD_COUNTRY_RES) {
				System.out.println("Added!");
			} else {
				((Exception) response.getPayload()).printStackTrace();
			}

			ois.close();
			oos.close();
			socket.close();
		} catch (Exception e) {
			throw new AtlasException(e);
		}
	}

	public Country search(String name) throws InvalidKeyException,
			CountryNotFoundException, AtlasException {
		try {
			Socket socket = new Socket("localhost", 1234);
			ObjectOutputStream oos = new ObjectOutputStream(
					socket.getOutputStream());

			PDU request = new PDU();
			request.setHeader(AtlasProtocol.SEARCH_COUNTRY_REQ);
			request.setPayload(name);
			System.out.println("Searching for counry ....");
			oos.writeObject(request);
			ObjectInputStream ois = new ObjectInputStream(
					socket.getInputStream());
			PDU response = (PDU) ois.readObject();
			if (response.getHeader() == AtlasProtocol.SEARCH_COUNTRY_RES) {
				ois.close();
				oos.close();
				socket.close();
				return (Country) response.getPayload();
			} else {
				ois.close();
				oos.close();
				socket.close();
				throw ((Exception) response.getPayload());
			}
		} catch (Exception e) {
			throw new AtlasException(e);
		}
	}

}
