package com.glarimy.atlas.biz;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import com.glarimy.atlas.api.AtlasException;
import com.glarimy.atlas.api.Country;

public class CountryDAO {
	PreparedStatement insert;
	PreparedStatement select;
	Connection connection;

	public CountryDAO() throws Exception {
		Class.forName("com.mysql.jdbc.Driver");
		connection = DriverManager.getConnection(
				"jdbc:mysql://localhost:3306/emc", "root", "admin");
		insert = connection
				.prepareStatement("insert into atlas values(?, ?, ?)");
		select = connection
				.prepareStatement("select * from atlas where country=?");

	}

	public void persist(Country country) throws AtlasException {
		try {
			insert.setString(1, country.getName());
			insert.setLong(2, country.getPopulation());
			insert.setString(3, country.getCapital());
			insert.execute();
		} catch (Exception e) {
			throw new AtlasException(e);
		}

	}

	public Country find(String pk) {
		try {
			select.setString(1, pk);
			ResultSet rs = select.executeQuery();
			if (rs.next()) {
				Country country = new Country();
				country.setName(rs.getString("country"));
				country.setPopulation(rs.getLong("population"));
				country.setCapital(rs.getString("capital"));
				return country;
			}
			throw new AtlasException("No record found");
		} catch (Exception e) {
			throw new AtlasException(e);
		}
	}

	@Override
	protected void finalize() throws Throwable {
		select.close();
		insert.close();
		connection.close();
	}
}