package com.glarimy.atlas.biz;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

import com.glarimy.atlas.api.Atlas;
import com.glarimy.atlas.api.AtlasProtocol;
import com.glarimy.atlas.api.Country;
import com.glarimy.atlas.api.PDU;

public class Job implements Runnable {
	private Socket connection;
	Atlas atlas;

	public Job(Socket connection) throws Exception {
		this.connection = connection;
		atlas = AtlasImpl.getInstance();
	}

	@Override
	public void run() {
		try {

			ObjectInputStream ois = new ObjectInputStream(
					connection.getInputStream());
			PDU request = (PDU) ois.readObject();
			PDU response = null;
			ObjectOutputStream oos = new ObjectOutputStream(
					connection.getOutputStream());
			switch (request.getHeader()) {
			case AtlasProtocol.ADD_COUNTRY_REQ:
				Country country = (Country) request.getPayload();

				try {
					atlas.add(country);
					response = new PDU(AtlasProtocol.ADD_COUNTRY_RES, null);
				} catch (Exception e) {
					response = new PDU(AtlasProtocol.ERROR, e);
				}
				oos.writeObject(response);
				break;
			case AtlasProtocol.SEARCH_COUNTRY_REQ:
				String name = (String) request.getPayload();
				try {
					Country result = atlas.search(name);
					response = new PDU(AtlasProtocol.SEARCH_COUNTRY_RES, result);
				} catch (Exception e) {
					response = new PDU(AtlasProtocol.ERROR, e);
				}
				oos.writeObject(response);
				break;
			default:
				response = new PDU(AtlasProtocol.ERROR, null);
				oos.writeObject(response);
			}
			oos.close();
			ois.close();
			connection.close();
		} catch (Exception e) {

		}
	}
}
