package com.glarimy.atlas.client;

import java.util.Scanner;

import com.glarimy.atlas.api.Atlas;
import com.glarimy.atlas.api.AtlasException;
import com.glarimy.atlas.api.Country;
import com.glarimy.atlas.api.CountryNotFoundException;
import com.glarimy.atlas.api.InvalidKeyException;
import com.glarimy.atlas.biz.AtlasImpl;

;

public class AtlasClient {

	public static void main(String[] args) {
		Atlas atlas;
		try {
			atlas = AtlasImpl.getInstance();
			atlas.add(new Country("a1", 1231, "c1"));
			atlas.add(new Country("a2", 1232, "c2"));
			atlas.add(new Country("a3", 1233, "c3"));
			System.out
					.println("Welcome to Atlas! Press ctrl+c at any time to exit!");
			Scanner scanner = new Scanner(System.in);
			while (true) {
				try {
					System.out.print("Enter country name: ");
					String name = scanner.nextLine();
					System.out.println(atlas.search(name));
				} catch (InvalidKeyException e) {
					System.out.println("Invalid key. Try again!");
					e.printStackTrace();
				} catch (CountryNotFoundException e) {
					System.out
							.println("Not in our database. Try something else!");
					e.printStackTrace();
				} catch (AtlasException e) {
					System.out
							.println("System error! Come back after sometime!");
					e.printStackTrace();
				}
			}
		} catch (Exception e) {
			System.out.println("System error! No use of coming back");
			e.printStackTrace();
		}

	}

}
