package com.glarimy.bank.api;

import java.util.ArrayList;

public interface Bank {
	public int openAccount(Person customerData) throws InvalidDataException,
			BankException;

	public double deposit(int number, double amount)
			throws AccountNotFoundException, InvalidStateException,
			InvalidAmountException, BankException;

	public double withdraw(int number, double amount)
			throws AccountNotFoundException, InvalidAmountException,
			InvalidStateException, InsufficientBalanceException, BankException;

	public boolean close(int number) throws AccountNotFoundException,
			InvalidStateException, BankException;

	public ArrayList<Transaction> history(int number)
			throws AccountNotFoundException, BankException;
}