package com.glarimy.java.dir.api;

/**
 * A directory to hold a maximum of 100 contacts.
 * 
 * @author Krishna
 * 
 */
public interface Directory {
	/**
	 * Adds a new contact. If there is a contact already with the same name, it
	 * overrides it.
	 * 
	 * @param contact
	 *            a non-null contact
	 */
	public void add(Contact contact);

	/**
	 * Lists out all the contacts in the directory
	 * 
	 * @return list of existing contacts
	 */
	public Contact[] list();

	/**
	 * Searches for the contact based on the first name
	 * 
	 * @param name
	 *            key
	 * @return Contact, if found. Null otherwise
	 */
	public Contact search(Name name);

	public void remove(Name name);
}
