package com.glarimy.threads;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

class LockedCounter {
    private int value;
    private Lock lock;

    public LockedCounter() {
        lock = new ReentrantLock();
    }

    public void count(long delay) {
        lock.lock();
        String name = Thread.currentThread().getName();
        for (int i = 0; i < 5; i++, value++) {
            System.out.println(name + " : " + value);
            try {
                Thread.sleep(delay);
            } catch (InterruptedException e) {
            }
        }
        lock.unlock();
    }
}

class CountingThread extends Thread {
    private LockedCounter counter;
    private long delay;

    public CountingThread(LockedCounter counter, long delay) {
        this.counter = counter;
        this.delay = delay;
    }

    @Override
    public void run() {
        counter.count(delay);
    }

    public static void main(String[] args) {
        LockedCounter counter = new LockedCounter();
        CountingThread one = new CountingThread(counter, 2000);
        CountingThread two = new CountingThread(counter, 5000);
        one.start();
        two.start();
    }
}
