package com.glarimy.threads;

public class Coordinator {
	public static void main(String[] args) {
		Worker one = new Worker(1000);
		Worker two = new Worker(2000);
		one.start();
		two.start();
	}
}

class Worker extends Thread {
	private Boolean ok = true;
	private int count = 10;
	private long delay;

	public Worker(long delay) {
		this.delay = delay;
	}

	public boolean isOk() {
		return ok;
	}

	public void setOk(boolean ok) {
		this.ok = ok;
	}

	@Override
	public void run() {
		synchronized (this) {
			while (true) {
				try {
					if (ok) {
						setOk(false);
						System.out.println(Thread.currentThread().getName()
								+ " : " + count--);
						Thread.sleep(delay);
						setOk(true);
						notifyAll();
					} else {
						wait();
					}
				} catch (Exception e) {
					
				}
			}

		}
	}
}