package com.glarimy.threads;

/**
 * Objective: To demonstrates sleep and join methods. 
 * Result: Child thread takes
 * 10 seconds to complete job and Main waits till then. 
 * Experiment: Comment
 * sleep and check main exits before child completes.
 */
public class Delegator {
	public static void main(String[] args) {
		System.out.println("Main: Creating a thread to count.");
		Thread thread = new Thread(new Counter(10));
		System.out.println("Main: Delegeting and waiting...");
		thread.start();
		try {
			thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("Main: Counting is done. Thanks");
	}
}

class Counter implements Runnable {
	private int limit;

	public Counter(int limit) {
		this.limit = limit;
	}

	@Override
	public void run() {
		int number = 0;
		while (limit-- > 0) {
			System.out.format("Counter: %d%n", number++);
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
				e.printStackTrace();
				return;
			}
		}
	}
}