package com.glarimy.threads;

class SharedCounter {
	private int value;
	private Object lock;

	public SharedCounter() {
		lock = new Object();
	}

	public void count(long delay) {

		String name = Thread.currentThread().getName();
		synchronized (lock) {
			for (int i = 0; i < 5; i++, value++) {
				System.out.println(name + " : " + value);
				try {
					Thread.sleep(delay);
				} catch (InterruptedException e) {
				}
			}
		}
	}
}

class FirstCountingThread extends Thread {
	private SharedCounter counter;
	private long delay;

	public FirstCountingThread(SharedCounter counter, long delay) {
		this.counter = counter;
		this.delay = delay;
	}

	@Override
	public void run() {
		counter.count(delay);
	}

	public static void main(String[] args) throws Exception {
		SharedCounter counter = new SharedCounter();
		FirstCountingThread one = new FirstCountingThread(counter, 20);
		FirstCountingThread two = new FirstCountingThread(counter, 50);
		one.start();
		two.start();
	}
}