package com.glarimy.threads;

/**
 * Objective: created
 * 
 */
/*
 * class Iterator { int count = 5; Object lock = new Object();
 * 
 * public void iterate(String caller, long delay) { while (count-- > 0) {
 * System.out.println(caller + " prints " + count); try { Thread.sleep(delay); }
 * catch (Exception e) {
 * 
 * } } } }
 */

class Iterator {
	int count = 5;
	Object lock = new Object();

	public void iterate(String caller, long delay) {
		synchronized (lock) {
			while (count-- > 0) {
				System.out.println(caller + " in action");
				try {
					Thread.sleep(delay);
				} catch (Exception e) {

				}
			}
		}
	}
}

class User extends Thread {
	private long delay;
	private Iterator iterator;
	private String caller;

	public User(String caller, Iterator iterator, long delay) {
		this.iterator = iterator;
		this.delay = delay;
		this.caller = caller;
	}

	@Override
	public void run() {
		iterator.iterate(caller, delay);
	}
}

public class Synchronizer {
	public static void main(String[] args) {
		Iterator iterator = new Iterator();
		User first = new User("First", iterator, 2000);
		User second = new User("Second", iterator, 1000);
		first.start();
		second.start();
	}
}